using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Web;
using System.Web.Services; 
using System.Xml;
using System.Web.Services.Protocols;

namespace WSException
{
	/// <summary>
	/// Summary description for Service1.
	/// </summary>
	/// 
	
	public class WSException  : System.Web.Services.WebService
	{

		public enum FaultCode
		{
			Client = 0,
			Server = 1
		}


		public WSException()
		{
			//CODEGEN: This call is required by the ASP.NET Web Services Designer
			InitializeComponent();
		}

		#region Component Designer generated code
		
		//Required by the Web Services Designer 
		private IContainer components = null;
				
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if(disposing && components != null)
			{
				components.Dispose();
			}
			base.Dispose(disposing);		
		}
		
		#endregion

		// WEB SERVICE EXAMPLE
		// The HelloWorld() example service returns the string Hello World
		// To build, uncomment the following lines then save and build the project
		// To test this web service, press F5

//		[WebMethod]
//		public string HelloWorld()
//		{
//			return "Hello World";
//		}

		[WebMethod]
		public void GetException()
		{
			try
			{
				int i = 1;
				int j = 0;
				int z;
    
				//generates the exception
				z = i/j;
			}
			catch(Exception ex)
			{
				throw 
					RaiseException("GetException", "WSSoapException", ex.Message,
					"1000", ex.Source, FaultCode.Server);
			}
		}

		//Creates the SOAP Exception object with all the error details
		public SoapException RaiseException(string uri,string webServiceNamespace,
			string errorMessage,
			string errorNumber,
			string errorSource,
			FaultCode code)
		{
			XmlQualifiedName faultCodeLocation = null;
			//Identify the location of the FaultCode
			switch (code)
			{
				case FaultCode.Client:
					faultCodeLocation = SoapException.ClientFaultCode;
					break;
				case FaultCode.Server:
					faultCodeLocation = SoapException.ServerFaultCode;
					break;
			}
			XmlDocument xmlDoc = new XmlDocument();
			//Create the Detail node
			XmlNode rootNode = xmlDoc.CreateNode(XmlNodeType.Element,
				SoapException.DetailElementName.Name,
				SoapException.DetailElementName.Namespace);
			//Build specific details for the SoapException
			//Add first child of detail XML element.
			XmlNode errorNode = xmlDoc.CreateNode(XmlNodeType.Element,"Error",
				webServiceNamespace);
			//Create and set the value for the ErrorNumber node
			XmlNode errorNumberNode = 
				xmlDoc.CreateNode(XmlNodeType.Element,"ErrorNumber",
				webServiceNamespace );
			errorNumberNode.InnerText = errorNumber;
			//Create and set the value for the ErrorMessage node
			XmlNode errorMessageNode =xmlDoc.CreateNode(XmlNodeType.Element,
				"ErrorMessage",
				webServiceNamespace);
			errorMessageNode.InnerText = errorMessage;
			//Create and set the value for the ErrorSource node
			XmlNode errorSourceNode = 
				xmlDoc.CreateNode(XmlNodeType.Element,"ErrorSource",
				webServiceNamespace);
			errorSourceNode.InnerText = errorSource;
			//Append the Error child element nodes to the root detail node.
			errorNode.AppendChild(errorNumberNode);
			errorNode.AppendChild(errorMessageNode);
			errorNode.AppendChild(errorSourceNode);
			//Append the Detail node to the root node
			rootNode.AppendChild(errorNode);
			//Construct the exception
			SoapException soapEx = new SoapException(errorMessage,
				faultCodeLocation, uri,
				rootNode);
			//Raise the exception  back to the caller
			return soapEx;
		}


	}
}
